Index: orxonox/trunk/src/lib/sound/sound_engine.cc
===================================================================
--- orxonox/trunk/src/lib/sound/sound_engine.cc	(revision 4885)
+++ orxonox/trunk/src/lib/sound/sound_engine.cc	(revision 4959)
@@ -467,4 +467,10 @@
 }
 
+void SoundEngine::listDevices()
+{
+
+  printf("%s\n",(const char*)alcGetString(NULL, ALC_DEVICE_SPECIFIER));
+}
+
 /*
 void SoundEngine::PrintALCErrorString(ALenum err)
Index: orxonox/trunk/src/lib/sound/sound_engine.h
===================================================================
--- orxonox/trunk/src/lib/sound/sound_engine.h	(revision 4885)
+++ orxonox/trunk/src/lib/sound/sound_engine.h	(revision 4959)
@@ -1,6 +1,6 @@
 /*!
-    \file sound_engine.h
-  *  Definition of the SoundEngine singleton Class
-*/
+ * @file sound_engine.h
+ * Definition of the SoundEngine singleton Class
+ */
 
 #ifndef _SOUND_ENGINE_H
@@ -22,16 +22,16 @@
 class SoundBuffer : public BaseObject
 {
- public:
-  SoundBuffer(const char* fileName);
-  ~SoundBuffer();
+  public:
+    SoundBuffer(const char* fileName);
+    ~SoundBuffer();
 
-  /** @returns the ID of the buffer used in this SoundBuffer */
-  inline ALuint getID() const { return this->bufferID; }
+    /** @returns the ID of the buffer used in this SoundBuffer */
+    inline ALuint getID() const { return this->bufferID; }
 
- private:
-  ALuint        bufferID;             //!< The address of the Buffer.
+  private:
+    ALuint        bufferID;             //!< The address of the Buffer.
 
-  ALsizei       size;                 //!< The size of the Buffer.
-  ALboolean     loop;                 //!< loop information.
+    ALsizei       size;                 //!< The size of the Buffer.
+    ALboolean     loop;                 //!< loop information.
 };
 
@@ -39,29 +39,29 @@
 class SoundSource : public BaseObject
 {
- public:
-  SoundSource(const PNode* sourceNode = NULL, const SoundBuffer* buffer = NULL);
-  ~SoundSource();
+  public:
+    SoundSource(const PNode* sourceNode = NULL, const SoundBuffer* buffer = NULL);
+    ~SoundSource();
 
   // user interaction
-  void play();
-  void play(const SoundBuffer* buffer);
-  void stop();
-  void pause();
-  void rewind();
+    void play();
+    void play(const SoundBuffer* buffer);
+    void stop();
+    void pause();
+    void rewind();
 
   // development functions
-  /** @returns The ID of this Source */
-  inline ALuint getID() const { return this->sourceID; }
-  /** @returns the SoundBuffer of this Source */
-  inline const SoundBuffer* getBuffer() const { return this->buffer; }
-  /** @returns the SourceNode of this Source */
-  inline const PNode* getNode() const { return this->sourceNode;}
+    /** @returns The ID of this Source */
+    inline ALuint getID() const { return this->sourceID; }
+    /** @returns the SoundBuffer of this Source */
+    inline const SoundBuffer* getBuffer() const { return this->buffer; }
+    /** @returns the SourceNode of this Source */
+    inline const PNode* getNode() const { return this->sourceNode;}
 
-  void setRolloffFactor(ALfloat rolloffFactor);
+    void setRolloffFactor(ALfloat rolloffFactor);
 
- private:
-  ALuint                 sourceID;              //!< The ID of the Source
-  const SoundBuffer*     buffer;                //!< The buffer to play in this source.
-  const PNode*           sourceNode;            //!< The SourceNode represente the position/velocity... of this source.
+  private:
+    ALuint                 sourceID;              //!< The ID of the Source
+    const SoundBuffer*     buffer;                //!< The buffer to play in this source.
+    const PNode*           sourceNode;            //!< The SourceNode represente the position/velocity... of this source.
 };
 
@@ -71,41 +71,44 @@
 class SoundEngine : public BaseObject {
 
- public:
-  virtual ~SoundEngine();
-  /** @returns a Pointer to the only object of this Class */
-  inline static SoundEngine* getInstance() { if (!singletonRef) singletonRef = new SoundEngine();  return singletonRef; };
+  public:
+    virtual ~SoundEngine();
+    /** @returns a Pointer to the only object of this Class */
+    inline static SoundEngine* getInstance() { if (!singletonRef) singletonRef = new SoundEngine();  return singletonRef; };
 
-  SoundSource* createSource(const char* fileName, PNode* sourceNode = NULL);
+    SoundSource* createSource(const char* fileName, PNode* sourceNode = NULL);
 
-  void setListener(PNode* listener);
-  void setDopplerValues(ALfloat dopplerFactor, ALfloat dopplerVelocity);
+    void setListener(PNode* listener);
+    void setDopplerValues(ALfloat dopplerFactor, ALfloat dopplerVelocity);
 
 
-  void addBuffer(SoundBuffer* buffer);
-  void removeBuffer(SoundBuffer* buffer);
-  void addSource(SoundSource* source);
-  void removeSource(SoundSource* source);
+    void addBuffer(SoundBuffer* buffer);
+    void removeBuffer(SoundBuffer* buffer);
+    void addSource(SoundSource* source);
+    void removeSource(SoundSource* source);
 
-  void update();
+    void update();
 
   // administrative
-  void flushUnusedBuffers();
-  void flushAllBuffers();
-  void flushAllSources();
-  bool initAudio();
+    void flushUnusedBuffers();
+    void flushAllBuffers();
+    void flushAllSources();
+    bool initAudio();
 
   // error handling:
-  static void PrintALErrorString(ALenum err);
+    static void PrintALErrorString(ALenum err);
   //  static void PrintALCErrorString(ALenum err);
 
 
- private:
-  SoundEngine();
-  static SoundEngine*      singletonRef;             //!< Reference to this class
+  private:
+    SoundEngine();
+    void listDevices();
+
+  private:
+    static SoundEngine*      singletonRef;             //!< Reference to this class
 
 
-  PNode*                   listener;                 //!< The listener of the Scene
-  tList<SoundBuffer>*      bufferList;               //!< A list of buffers
-  tList<SoundSource>*      sourceList;               //!< A list for all the sources in the scene.
+    PNode*                   listener;                 //!< The listener of the Scene
+    tList<SoundBuffer>*      bufferList;               //!< A list of buffers
+    tList<SoundSource>*      sourceList;               //!< A list for all the sources in the scene.
 
 };