Index: /orxonox/trunk/Makefile.am
===================================================================
--- /orxonox/trunk/Makefile.am	(revision 4975)
+++ /orxonox/trunk/Makefile.am	(revision 4976)
@@ -5,4 +5,5 @@
 EXTRA_DIST = CODING-STANDARDS \
              IDEAS \
+             NEWS \
              doc/CREDITS \
              doc/doxyconf/build \
Index: /orxonox/trunk/Makefile.in
===================================================================
--- /orxonox/trunk/Makefile.in	(revision 4975)
+++ /orxonox/trunk/Makefile.in	(revision 4976)
@@ -184,4 +184,5 @@
 EXTRA_DIST = CODING-STANDARDS \
              IDEAS \
+             NEWS \
              doc/CREDITS \
              doc/doxyconf/build \
Index: /orxonox/trunk/src/Makefile.am
===================================================================
--- /orxonox/trunk/src/Makefile.am	(revision 4975)
+++ /orxonox/trunk/src/Makefile.am	(revision 4976)
@@ -52,4 +52,5 @@
                   world_entities/camera.cc \
                   world_entities/player.cc \
+                  world_entities/npc.cc \
                   world_entities/environment.cc \
                   world_entities/skysphere.cc \
Index: /orxonox/trunk/src/Makefile.in
===================================================================
--- /orxonox/trunk/src/Makefile.in	(revision 4975)
+++ /orxonox/trunk/src/Makefile.in	(revision 4976)
@@ -65,7 +65,7 @@
 	orxonox-world.$(OBJEXT) orxonox-world_entity.$(OBJEXT) \
 	orxonox-camera.$(OBJEXT) orxonox-player.$(OBJEXT) \
-	orxonox-environment.$(OBJEXT) orxonox-skysphere.$(OBJEXT) \
-	orxonox-skybox.$(OBJEXT) orxonox-terrain.$(OBJEXT) \
-	orxonox-satellite.$(OBJEXT) \
+	orxonox-npc.$(OBJEXT) orxonox-environment.$(OBJEXT) \
+	orxonox-skysphere.$(OBJEXT) orxonox-skybox.$(OBJEXT) \
+	orxonox-terrain.$(OBJEXT) orxonox-satellite.$(OBJEXT) \
 	orxonox-character_attributes.$(OBJEXT) \
 	orxonox-test_entity.$(OBJEXT) orxonox-weapon_manager.$(OBJEXT) \
@@ -108,4 +108,5 @@
 @AMDEP_TRUE@	./$(DEPDIR)/orxonox-light.Po \
 @AMDEP_TRUE@	./$(DEPDIR)/orxonox-load_param.Po \
+@AMDEP_TRUE@	./$(DEPDIR)/orxonox-npc.Po \
 @AMDEP_TRUE@	./$(DEPDIR)/orxonox-null_parent.Po \
 @AMDEP_TRUE@	./$(DEPDIR)/orxonox-orxonox.Po \
@@ -304,4 +305,5 @@
                   world_entities/camera.cc \
                   world_entities/player.cc \
+                  world_entities/npc.cc \
                   world_entities/environment.cc \
                   world_entities/skysphere.cc \
@@ -502,4 +504,5 @@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/orxonox-light.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/orxonox-load_param.Po@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/orxonox-npc.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/orxonox-null_parent.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/orxonox-orxonox.Po@am__quote@
@@ -865,4 +868,20 @@
 @AMDEP_TRUE@@am__fastdepCXX_FALSE@	$(CXXDEPMODE) $(depcomp) @AMDEPBACKSLASH@
 @am__fastdepCXX_FALSE@	$(CXX) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(orxonox_CPPFLAGS) $(CPPFLAGS) $(AM_CXXFLAGS) $(CXXFLAGS) -c -o orxonox-player.obj `if test -f 'world_entities/player.cc'; then $(CYGPATH_W) 'world_entities/player.cc'; else $(CYGPATH_W) '$(srcdir)/world_entities/player.cc'; fi`
+
+orxonox-npc.o: world_entities/npc.cc
+@am__fastdepCXX_TRUE@	if $(CXX) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(orxonox_CPPFLAGS) $(CPPFLAGS) $(AM_CXXFLAGS) $(CXXFLAGS) -MT orxonox-npc.o -MD -MP -MF "$(DEPDIR)/orxonox-npc.Tpo" -c -o orxonox-npc.o `test -f 'world_entities/npc.cc' || echo '$(srcdir)/'`world_entities/npc.cc; \
+@am__fastdepCXX_TRUE@	then mv -f "$(DEPDIR)/orxonox-npc.Tpo" "$(DEPDIR)/orxonox-npc.Po"; else rm -f "$(DEPDIR)/orxonox-npc.Tpo"; exit 1; fi
+@AMDEP_TRUE@@am__fastdepCXX_FALSE@	source='world_entities/npc.cc' object='orxonox-npc.o' libtool=no @AMDEPBACKSLASH@
+@AMDEP_TRUE@@am__fastdepCXX_FALSE@	depfile='$(DEPDIR)/orxonox-npc.Po' tmpdepfile='$(DEPDIR)/orxonox-npc.TPo' @AMDEPBACKSLASH@
+@AMDEP_TRUE@@am__fastdepCXX_FALSE@	$(CXXDEPMODE) $(depcomp) @AMDEPBACKSLASH@
+@am__fastdepCXX_FALSE@	$(CXX) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(orxonox_CPPFLAGS) $(CPPFLAGS) $(AM_CXXFLAGS) $(CXXFLAGS) -c -o orxonox-npc.o `test -f 'world_entities/npc.cc' || echo '$(srcdir)/'`world_entities/npc.cc
+
+orxonox-npc.obj: world_entities/npc.cc
+@am__fastdepCXX_TRUE@	if $(CXX) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(orxonox_CPPFLAGS) $(CPPFLAGS) $(AM_CXXFLAGS) $(CXXFLAGS) -MT orxonox-npc.obj -MD -MP -MF "$(DEPDIR)/orxonox-npc.Tpo" -c -o orxonox-npc.obj `if test -f 'world_entities/npc.cc'; then $(CYGPATH_W) 'world_entities/npc.cc'; else $(CYGPATH_W) '$(srcdir)/world_entities/npc.cc'; fi`; \
+@am__fastdepCXX_TRUE@	then mv -f "$(DEPDIR)/orxonox-npc.Tpo" "$(DEPDIR)/orxonox-npc.Po"; else rm -f "$(DEPDIR)/orxonox-npc.Tpo"; exit 1; fi
+@AMDEP_TRUE@@am__fastdepCXX_FALSE@	source='world_entities/npc.cc' object='orxonox-npc.obj' libtool=no @AMDEPBACKSLASH@
+@AMDEP_TRUE@@am__fastdepCXX_FALSE@	depfile='$(DEPDIR)/orxonox-npc.Po' tmpdepfile='$(DEPDIR)/orxonox-npc.TPo' @AMDEPBACKSLASH@
+@AMDEP_TRUE@@am__fastdepCXX_FALSE@	$(CXXDEPMODE) $(depcomp) @AMDEPBACKSLASH@
+@am__fastdepCXX_FALSE@	$(CXX) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(orxonox_CPPFLAGS) $(CPPFLAGS) $(AM_CXXFLAGS) $(CXXFLAGS) -c -o orxonox-npc.obj `if test -f 'world_entities/npc.cc'; then $(CYGPATH_W) 'world_entities/npc.cc'; else $(CYGPATH_W) '$(srcdir)/world_entities/npc.cc'; fi`
 
 orxonox-environment.o: world_entities/environment.cc
Index: /orxonox/trunk/src/ai/ai.h
===================================================================
--- /orxonox/trunk/src/ai/ai.h	(revision 4975)
+++ /orxonox/trunk/src/ai/ai.h	(revision 4976)
@@ -3,5 +3,4 @@
 #define _AI_H
 
-#include "data_tank.h"
 
 class AI {
Index: /orxonox/trunk/src/story_entities/world.cc
===================================================================
--- /orxonox/trunk/src/story_entities/world.cc	(revision 4975)
+++ /orxonox/trunk/src/story_entities/world.cc	(revision 4976)
@@ -71,5 +71,5 @@
 
 #include "cd_engine.h"
-
+#include "npc.h"
 
 using namespace std;
@@ -521,4 +521,14 @@
   PhysicsEngine::getInstance()->debug();
 
+  for(int i = 0; i < 100; i++)
+  {
+    WorldEntity* tmp = new NPC();
+    tmp->setAbsCoor(((float)rand()/RAND_MAX) * 2000, 40+ (float)rand()/RAND_MAX*30, ((float)rand()/RAND_MAX -.5) *500);
+    this->spawn(tmp);
+
+
+  }
+
+
 
   ClassList::debug();
Index: /orxonox/trunk/src/world_entities/npc.cc
===================================================================
--- /orxonox/trunk/src/world_entities/npc.cc	(revision 4975)
+++ /orxonox/trunk/src/world_entities/npc.cc	(revision 4976)
@@ -20,5 +20,4 @@
 
 #include "ai.h"
-#include "data_tank.h"
 
 #include "npc.h"
@@ -27,8 +26,10 @@
 
 
-NPC::NPC() : WorldEntity()
+NPC::NPC()
 {
   this->setClassID(CL_NPC, "NPC");
   hasDied = 0;
+
+  this->loadModel("models/bolido.obj");
 }
 
@@ -59,25 +60,4 @@
 
 
-void NPC::addAI(AI* ai)
-{}
-
-void NPC::paint()
-{
-  //cout << "WorldEntity::WorldEntity();" << endl;
-  /* fix: died flag approach is very stupid, just to show @ convention */
-  if( hasDied == 0 ) {
-    glPushMatrix();
-    glTranslatef(xCor, yCor, 3.0);
-    //glScalef(1.0, 3.0, 1.0);
-    glutWireSphere(1.0, 10, 10);
-    glPopMatrix();
-  }
-}
-
-void NPC::drawNPC()
-{
-
-}
-
 
 /* define the reaction, if the ship is been hit */