Index: /orxonox/trunk/src/story_entities/world.cc
===================================================================
--- /orxonox/trunk/src/story_entities/world.cc	(revision 4976)
+++ /orxonox/trunk/src/story_entities/world.cc	(revision 4977)
@@ -20,5 +20,4 @@
 #include "world.h"
 
-#include "orxonox.h"
 
 #include "state.h"
@@ -75,67 +74,4 @@
 using namespace std;
 
-WorldInterface* WorldInterface::singletonRef = 0;
-
-
-/**
- *  private constructor because of singleton
-*/
-WorldInterface::WorldInterface()
-{
-  this->worldIsInitialized = false;
-  this->worldReference = NULL;
-}
-
-/**
- *  public deconstructor
-*/
-WorldInterface::~WorldInterface()
-{
-  this->singletonRef = NULL;
-  this->worldIsInitialized = false;
-  this->worldReference = NULL;
-}
-
-/**
- *  gets the singleton instance
- * @returns singleton instance
-*/
-WorldInterface* WorldInterface::getInstance()
-{
-  if( singletonRef == NULL)
-    singletonRef = new WorldInterface();
-  return singletonRef;
-}
-
-
-/**
- *  initializes the interface
- * @param reference to the world
-
-   if the worldinterface is not initilizes, there wont be any
-   useable interface
-*/
-void WorldInterface::init(World* world)
-{
-  this->worldReference = world;
-  if( world != NULL)
-    {
-      this->worldIsInitialized = true;
-      PRINTF(3)("WorldInterface up and running\n");
-    }
-}
-
-
-/**
- *  gets the entity list from the world
- * @return entity list
-*/
-tList<WorldEntity>* WorldInterface::getEntityList()
-{
-  if( this->worldIsInitialized)
-    return this->worldReference->getEntities();
-  PRINT(1)("tried to use the WorldInterface before it has been initizlized! this can result in SEGFAULTs!\n");
-  return NULL;
-}
 
 CREATE_FACTORY(World);
@@ -183,5 +119,4 @@
   ParticleEngine::getInstance()->debug();
 
-  delete WorldInterface::getInstance();
   delete this->entities;
   State::setWorldEntityList(NULL);
@@ -266,6 +201,4 @@
 
   /* init the world interface */
-  WorldInterface* wi = WorldInterface::getInstance();
-  wi->init(this);
 
   LightManager::getInstance();
@@ -677,8 +610,4 @@
         EventHandler::getInstance()->subscribe(this->pilotNode, ES_GAME, EV_MOUSE_MOTION);
 
-        // bind input
-        Orxonox *orx = Orxonox::getInstance ();
-        //orx->getLocalInput()->bind (this->pilotNode);
-
         /*
         PNode* tn = TrackManager::getInstance()->getTrackNode();
Index: /orxonox/trunk/src/story_entities/world.h
===================================================================
--- /orxonox/trunk/src/story_entities/world.h	(revision 4976)
+++ /orxonox/trunk/src/story_entities/world.h	(revision 4977)
@@ -25,25 +25,4 @@
 
 class OggPlayer;
-//! The game world Interface
-/**
-   this is a singleton interface, that enables world_entities to access the
-   world. for those objects, there is no easier way than over this interface!
-*/
-class WorldInterface : BaseObject {
-
- public:
-  ~WorldInterface();
-  static WorldInterface* getInstance();
-  void init(World* world);
-  inline World* getCurrentWorld() {return this->worldReference;}
-  tList<WorldEntity>* getEntityList();
-
- private:
-  WorldInterface();
-  static WorldInterface* singletonRef;    //!< singleton reference to this object
-  bool worldIsInitialized;                //!< true if the world has been initialized
-  World* worldReference;                  //!< this is a reference to the running world
-
-};
 
 //! The game world
@@ -114,4 +93,5 @@
 
   OggPlayer* music;
+
   // IMPORTANT WORLD-ENTITIES
   PNode* nullParent;                  //!< The zero-point, that everything has as its parent.
Index: /orxonox/trunk/src/world_entities/npc.cc
===================================================================
--- /orxonox/trunk/src/world_entities/npc.cc	(revision 4976)
+++ /orxonox/trunk/src/world_entities/npc.cc	(revision 4977)
@@ -16,8 +16,6 @@
 */
 
-#include <iostream>
-#include <GL/glut.h>
 
-#include "ai.h"
+//#include "ai.h"
 
 #include "npc.h"
@@ -29,5 +27,4 @@
 {
   this->setClassID(CL_NPC, "NPC");
-  hasDied = 0;
 
   this->loadModel("models/bolido.obj");
@@ -35,27 +32,4 @@
 
 NPC::~NPC () {}
-
-
-void NPC::setPosition(float x, float y, float z)
-{
-  xCor = x; yCor = y; zCor = z;
-}
-
-void NPC::getPosition(float* x, float* y, float* z)
-{
-  *x = xCor;
-  *y = yCor;
-  *z = zCor;
-}
-
-void NPC::setCollisionRadius(float r)
-{
-  collisionRadius = r;
-}
-
-float NPC::getCollisionRadius()
-{
-  return collisionRadius;
-}
 
 
@@ -71,4 +45,3 @@
 void NPC::die()
 {
-  hasDied = 1;
 }
Index: /orxonox/trunk/src/world_entities/npc.h
===================================================================
--- /orxonox/trunk/src/world_entities/npc.h	(revision 4976)
+++ /orxonox/trunk/src/world_entities/npc.h	(revision 4977)
@@ -13,18 +13,7 @@
   ~NPC ();
 
-  /* collision control */
-  float collisionRadius;
 
-  float xCor;
-  float yCor;
-  float zCor;
+  void addAI(AI* ai);
 
-  void drawNPC();
-  void paint();
-  void setPosition(float x, float y, float z);
-  void getPosition(float* x, float* y, float* z);
-  void addAI(AI* ai);
-  void setCollisionRadius(float r);
-  float getCollisionRadius();
   int hit();
   void die();
@@ -32,9 +21,4 @@
  private:
   /* position of the non player space craft */
-
-  int npcType;
-  int hasDied;
-
-
 ;
 